---
title: EffectTiming.duration
slug: Web/API/EffectTiming/duration
tags:
  - API
  - Animation
  - EffectTiming
  - Experimental
  - KeyframeEffect
  - Property
  - Reference
  - Web Animations
  - animate
  - duration
  - waapi
  - web animations api
---
<div>{{ SeeCompatTable() }}{{ APIRef("Web Animations") }}</div>

<p>The <strong><code>duration</code></strong> property of the dictionary {{domxref("EffectTiming")}} in the <a href="/en-US/docs/Web/API/Web_Animations_API">Web Animations API</a> specifies the duration in milliseconds that a single iteration (from beginning to end) the animation should take to complete.</p>

<div class="note">
<p>{{domxref("Element.animate()")}}, {{domxref("KeyframeEffectReadOnly.KeyframeEffectReadOnly", "KeyframeEffectReadOnly()")}}, and {{domxref("KeyframeEffect.KeyframeEffect", "KeyframeEffect()")}} all accept an object of timing properties including <code>duration</code>. The value of <code>duration</code> corresponds directly to {{domxref("AnimationEffectTimingReadOnly.duration")}} in {{domxref("AnimationEffectReadOnly.timing", "timing")}} objects returned by {{domxref("AnimationEffectReadOnly")}}, {{domxref("KeyframeEffectReadOnly")}}, and {{domxref("KeyframeEffect")}}.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>timingProperties</em> = {
  duration: <em>durationInMilliseconds</em> | "auto"
};

<em>timingProperties</em>.duration = <em>durationInMilliseconds</em> | "auto";
</pre>

<h3 id="Value">Value</h3>

<p>The number of milliseconds long a single beginning-to-end iteration of the animation should take. The default is <code>"auto"</code>. This value must not be negative; otherwise, it can have any value (including positive infinity).</p>

<div class="note">
<p>Currently, a value of <code>"auto"</code> is the same as specifying 0.0. This is a forwards-compatiblity measure since in the future, "auto" will be expanded to take into account the duration of any child effects. Consider using <code>"auto"</code> rather than 0 if that makes sense.</p>
</div>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>TypeError</code></dt>
 <dd>The specified value is either a string other than <code>"auto"</code>, a number less than zero, {{jsxref("NaN")}}, or some other type of object entirely.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>In the <a href="http://codepen.io/rachelnabors/pen/EPJdJx?editors=0010">Pool of Tears</a> example, each tear is passed a random <code>duration</code> via its timing object:</p>

<pre class="brush: js">// Randomizer function
var getRandomMsRange = function(min, max) {
  return Math.random() * (max - min) + min;
}

// Loop through each tear
tears.forEach(function(el) {

  // Animate each tear
  el.animate(
    tearsFalling,
    {
       delay: getRandomMsRange(-1000, 1000), // randomized for each tear
       duration: getRandomMsRange(2000, 6000), // randomized for each tear
       iterations: Infinity,
       easing: "cubic-bezier(0.6, 0.04, 0.98, 0.335)"
    });
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Animations', '#iteration-duration', 'duration' )}}</td>
   <td>{{Spec2('Web Animations')}}</td>
   <td>Editor's draft.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.EffectTiming.duration")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Animations_API">Web Animations API</a></li>
 <li>{{domxref("Element.animate()")}}, {{domxref("KeyframeEffectReadOnly.KeyframeEffectReadOnly", "KeyframeEffectReadOnly()")}}, and {{domxref("KeyframeEffect.KeyframeEffect", "KeyframeEffect()")}} all accept an object of timing properties including this one.</li>
 <li>The value of this property corresponds to property of the same name in {{domxref("AnimationEffectReadOnly.timing")}}, {{domxref("KeyframeEffectReadOnly.timing")}}, and {{domxref("KeyframeEffect.timing")}}).</li>
 <li>CSS's {{cssxref("transition-duration")}} and {{cssxref("animation-duration")}} properties</li>
</ul>
